#include "stdafx.h"
#include <string.h>

wchar_t *optarg;

int getopt(int argc, wchar_t **argv,wchar_t *opts)
{
	static int strIdx=1;
	static int argIdx=1;
    int curOpt;
	wchar_t *optsP;

	optarg=NULL;
	if(strIdx==1)
		if(argIdx>=argc || argv[argIdx][0]!='-' || argv[argIdx][1]=='\0')
			return -1;
		else if(wcscmp(argv[argIdx],L"--")==0){
			argIdx++;
            return -1;
        }
	curOpt=argv[argIdx][strIdx];
    if((optsP=wcschr(opts,curOpt))==NULL || curOpt==':'){
		fwprintf(stderr,L"unknown option -%c\n",(wchar_t)curOpt);
	    if(argv[argIdx][++strIdx]=='\0'){
			argIdx++;
			strIdx=1;
		}
		return '?';
    }
    if(*++optsP==':') {
        if(argv[argIdx][strIdx+1]!='\0')
            optarg=&argv[argIdx++][strIdx+1];
		else if(++argIdx>=argc){
			fwprintf(stderr,L"argument missing for -%c\n", (wchar_t)curOpt);
			strIdx=1;
            return '?';
        }else
            optarg=argv[argIdx++];
        strIdx=1;
    }else{
        if(argv[argIdx][++strIdx]=='\0'){
            strIdx=1;
            argIdx++;
        }
    }
    return curOpt;
}